package jrunner;

import java.util.*;

public class CommandTokenizer{
    Enumeration en=null;
    int numTokens;
    String del=" \t\n\r"; 
    public String out = null, in = null;


    public CommandTokenizer(String s){
       Vector tokens = new Vector();

       if(s==null || s.length()==0) return;

       int i=0;
       boolean isOut=false, isIn=false;
       while(true){
           while( i<s.length() && isdel(s.charAt(i)) ) i++;
           if(i==s.length()) break;
           if(s.charAt(i)=='<'){
               isIn = true; i++;
           }else if(s.charAt(i)=='>'){
               isOut = true; i++;
           }else if(s.charAt(i)=='"'){
               i++;
               if(i==s.length()) break;
               int k=i+1;
               while( k<s.length() && s.charAt(k)!= '"' ) k++;
               if(k==s.length()) break;
               if(isIn){
                   in = s.substring(i,k); isIn = false;
               }else if(isOut){
                   out = s.substring(i,k); isOut = false;
               }else
                   tokens.addElement(s.substring(i,k));
               i=k+1;
           }else{
               int k=i+1;
               while( k<s.length() && !isdel(s.charAt(k))) k++; 
               if(k==s.length()){
                   if(isIn){
                       in = s.substring(i); isIn = false;
                   }else if(isOut){
                       out = s.substring(i); isOut = false;
                   }else
                       tokens.addElement(s.substring(i));
                   break;
               }else{
                   if(isIn){
                       in = s.substring(i,k); isIn = false;
                   }else if(isOut){
                       out = s.substring(i,k); isOut = false;
                   }else
                       tokens.addElement(s.substring(i,k));
                   i=k+1;
               }
           }
       }
	   // Expand wildcards
	   for(i=0; i<tokens.size(); i++){
	   		String st = (String)tokens.elementAt(i);
			if(st.indexOf('*')>=0){
				tokens.removeElementAt(i);
				Enumeration e = expandWildcard(st);
				if(e!=null){
					while(e.hasMoreElements())
						tokens.addElement(e.nextElement());
				}
			}
	   }
       en = tokens.elements();
       numTokens = tokens.size();
     }

	private Enumeration expandWildcard(String s){
		return null;
	}


     private boolean isdel(char c){
         for(int i=0; i<del.length(); i++)
             if(del.charAt(i) == c)
                  return true;
         return false;
     }
     
     public boolean hasMoreElements(){
         return hasMoreTokens();
     }

     public boolean hasMoreTokens(){
         if(en==null)
              return false;
         return en.hasMoreElements();
     }

     public String nextToken(){
         if(en==null)
              return null;
         numTokens--;
         return (String)en.nextElement();
     }

     public int countTokens(){
         return numTokens;
     }

 }
